package org.dromara.work.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.system.mapper.SysPictureMapper;
import org.springframework.stereotype.Service;
import org.dromara.work.domain.bo.TpWorksBo;
import org.dromara.work.domain.vo.TpWorksVo;
import org.dromara.work.domain.TpWorks;
import org.dromara.work.mapper.TpWorksMapper;
import org.dromara.work.service.ITpWorksService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 作品收藏Service业务层处理
 *
 * @author Maosw
 * @date 2025-07-23
 */
@RequiredArgsConstructor
@Service
public class TpWorksServiceImpl implements ITpWorksService {

    private final TpWorksMapper baseMapper;

    private final SysPictureMapper sysPictureMapper;

    /**
     * 查询作品收藏
     *
     * @param id 主键
     * @return 作品收藏
     */
    @Override
    public TpWorksVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询作品收藏列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 作品收藏分页列表
     */
    @Override
    public TableDataInfo<TpWorksVo> queryPageList(TpWorksBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TpWorks> lqw = buildQueryWrapper(bo);
        Page<TpWorksVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);

        //作品对象
        result.getRecords().forEach(r -> r.setPicture(sysPictureMapper.selectById(r.getPictureId())));
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的作品收藏列表
     *
     * @param bo 查询条件
     * @return 作品收藏列表
     */
    @Override
    public List<TpWorksVo> queryList(TpWorksBo bo) {
        LambdaQueryWrapper<TpWorks> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TpWorks> buildQueryWrapper(TpWorksBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TpWorks> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(TpWorks::getId);
        lqw.eq(bo.getUserId() != null, TpWorks::getUserId, bo.getUserId());
        lqw.eq(bo.getPictureId() != null, TpWorks::getPictureId, bo.getPictureId());
        return lqw;
    }

    /**
     * 新增作品收藏
     *
     * @param bo 作品收藏
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TpWorksBo bo) {
        TpWorks add = MapstructUtils.convert(bo, TpWorks.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改作品收藏
     *
     * @param bo 作品收藏
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TpWorksBo bo) {
        TpWorks update = MapstructUtils.convert(bo, TpWorks.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TpWorks entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除作品收藏信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }

    /**
     * 根据条件查询作品收藏
     *
     * @param bo 查询条件
     * @return 作品收藏
     */
    @Override
    public TpWorksVo queryByTpWorks(TpWorksBo bo) {
        return baseMapper.selectVoOne(new LambdaQueryWrapper<TpWorks>().eq(TpWorks::getUserId, bo.getUserId()).eq(TpWorks::getPictureId, bo.getPictureId()));
    }
}
